# -*- coding: utf-8 -*-
from openerp import models, fields, api, exceptions, _
from lxml import etree


class stock_picking(models.Model):
    _inherit = 'stock.picking'

    @api.cr_uid_ids_context
    def do_transfer(self, cr, uid, picking_ids, context=None):
        res = super(stock_picking, self).do_transfer(cr, uid, picking_ids, context)
        # Recompute locations of lots involved
        for picking in self.browse(cr, uid, picking_ids, context=context):
            lot_ids = picking.pack_operation_ids.mapped('lot_id')
            lot_ids.action_update_last_location()
        return res


class stock_quant(models.Model):
    _inherit = 'stock.quant'

    @api.model
    def fields_view_get(self, view_id=None, view_type='form', toolbar=False, submenu=False):
        res = super(stock_quant, self).fields_view_get(view_id=view_id, view_type=view_type, toolbar=toolbar, submenu=submenu)
        # spt_id = self._context.get('default_picking_type_id')
        if view_type in ('search', 'tree') and self.env.user.pos_config:
            # spt = self.env['stock.picking.type'].browse(spt_id)
            poscfg = self.env.user.pos_config
            doc = etree.XML(res['arch'])
            locations_pos = [poscfg.stock_location_transit_id.id, poscfg.stock_location_id.id]
            for node in doc.xpath("//filter[@name='my_pos_location']"):
                domain = "[('location_id.id', 'in', %s)]" % locations_pos
                node.set('domain', domain)
            res['arch'] = etree.tostring(doc)
        return res


class stock_production_lot(models.Model):
    _inherit = 'stock.production.lot'

    @api.multi
    def action_update_last_location(self):
        for record in self:
            if record.quant_ids.ids:
                last_quant_id = max(record.quant_ids.ids)
                last_quant_data = self.env['stock.quant'].browse(last_quant_id)
                record.last_location_id = last_quant_data.location_id.id
            else:
                record.last_location_id = False
