function calcular() {
    // Input
    var cuotas = tabla_json[$("#cuotas").val()]["cuotas"];
    if ($("#precio").val() == "") $("#precio").val("100");

    var precio_str = $("#precio").val().replace(/\ /g, "").replace(/\$/g, "");
    if ((precio_str.match(/\./g) || []).length > 1) precio_str = precio_str.replace(/\./g, "");
    if ((precio_str.match(/,/g) || []).length > 1) precio_str = precio_str.replace(/,/g, "");
    else precio_str = precio_str.replace(",", ".");
    var precio = precio_str * 1.00;
    
    if (tabla_json[$("#cuotas").val()]["directo"]) {
        // Planes especiales del gobierno, tasa directa
        var tea = tabla_json[$("#cuotas").val()]["tea"];
        var cft = tabla_json[$("#cuotas").val()]["cft"];
        var coeficiente_con_iva = tabla_json[$("#cuotas").val()]["coeficiente"];
    } else {
        // Resto de los planes, se calculan
       
        // Input
        var tna_str = $("#tna").val().replace(/\ /g, "").replace(/\%/g, "");
        if ((tna_str.match(/\./g) || []).length > 1) tna_str = tna_str.replace(/\./g, "");
        if ((tna_str.match(/,/g) || []).length > 1) tna_str = tna_str.replace(/,/g, "");
        else tna_str = tna_str.replace(",", ".");
        var tna = tna_str / 100;

        var tea = (Math.pow((1 + (tna / cuotas)), cuotas) - 1);
        
        // Constantes
        var iva = 0.21;
        var arancel = 0.025;
        var dias_ano = 360;
        var dias_mes = 30;
        var dias_adelanto = 2;
        var dias_primer = dias_mes - dias_adelanto;
        
        // Calculos
        var pago_comercio = 0;
        // Calculo el acumulado de los pagos presenciales al comercio
        var cuota_sin_arancel = precio * (1-arancel) / cuotas;
        for (c = 0; c < cuotas; c++) {
            pago_comercio = pago_comercio + (cuota_sin_arancel / ((1+((dias_primer/dias_ano)*tna)) * Math.pow((1+((dias_mes/dias_ano)*tna)), c)));
        }
        var coeficiente_sin_iva = precio * (1-arancel) / pago_comercio;
        var tasa_directa = (1-arancel) - ((1-arancel) / coeficiente_sin_iva);
        var coeficiente_con_iva = (100 / (1-(tasa_directa * (1+iva)))) / 100;
        var precio_total_financiado = precio * coeficiente_con_iva;
        var descuento_financ_otorgante = precio_total_financiado * tasa_directa;
        var cuota_con_iva = (precio * coeficiente_con_iva) / cuotas;
        var cuota_financiada = precio_total_financiado / cuotas;

        // CFT
        var cft_array = [];
        cft_array.push({Date: 0, Flow: (-1 * precio)});
        for (c = 1; c <= cuotas; c++) {
            var d = (c == 1 ? dias_primer : dias_mes * c);
            cft_array.push({Date: d, Flow: cuota_con_iva});
        }
        var cft = XIRR(cft_array);
        
        // TEA
        var tea_array = [];
        tea_array.push({Date: 0, Flow: (-1 * (precio_total_financiado - descuento_financ_otorgante))});
        for (c = 1; c <= cuotas; c++) {
            var d = (c == 1 ? dias_primer : dias_mes * c);
            tea_array.push({Date: d, Flow: cuota_financiada});
        }
        var tea = XIRR(tea_array);
    }
    
    var coeficiente = coeficiente_con_iva;
    var valor_total = precio * coeficiente;
    var valor_cuota = (precio * coeficiente) / cuotas;
        
    $("#tea").text(numberWithCommas(tea * 100, 2) + "%");
    $("#cft").text(numberWithCommas(cft * 100, 2) + "%");
    $("#valor_contado").text("$" + numberWithCommas(precio, 2));
    $("#cant_cuotas").text($("#cuotas").val());
    $("#valor_total").text("$" + numberWithCommas(valor_total, 2));
    $("#valor_cuota").text("$" + numberWithCommas(valor_cuota, 2));
    $("#coeficiente").text(numberWithCommas(coeficiente, 4));
}
